<?php

/*------------------------------------------------------------------------
# "Hot Joomla Carousel Pro" Joomla module
# Copyright (C) 2010 HotThemes. All Rights Reserved.
# License: http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
# Author: HotJoomlaTemplates.com
# Website: http://www.hotjoomlatemplates.com
-------------------------------------------------------------------------*/

defined('_JEXEC') or die('Restricted access'); // no direct access

// get the document object
$doc =& JFactory::getDocument();

//unique identifier of module instance
$uid = rand(0,100000);

// add your stylesheet
$doc->addStyleSheet( 'modules/mod_hot_joomla_carousel_pro/tmpl/hot_joomla_carousel_pro.css' );

if($buttonRadius) {
	$buttonRadiusHTML = '-moz-border-radius:'.$buttonRadius.'px; ';
	$buttonRadiusHTML .= '-webkit-border-radius:'.$buttonRadius.'px;';
	$buttonRadiusHTML .= 'border-radius:'.$buttonRadius.'px;';
}

// style declaration
$doc->addStyleDeclaration( '

#hotcarouselmodule-'.$uid.'.hotcarousel li.carouselimage img {
	border:'.$objectBorderWidth.'px solid '.$objectBorderColor.';
	margin:'.$objectMarginReal.'px;
	padding:'.$objectPadding.'px;
}

#hotcarouselmodule-'.$uid.'.hotcarousel li .carouselarticle {
	border:'.$objectBorderWidth.'px solid '.$objectBorderColor.';
	margin:'.$objectMarginReal.'px;
	padding:'.$objectPadding.'px;
	width:'.$objectWidth.'px;
	height:'.$objectHeight.'px;
	overflow:hidden;
}

#hotcarouselmodule-'.$uid.'.hotcarousel .js {
	overflow:hidden;
	width:100%;
	height:'.$moduleHeight.'px;
}

#hotcarouselmodule-'.$uid.'.hotcarousel .carousel-next {
	background: url('.$mosConfig_live_site.'/modules/mod_hot_joomla_carousel_pro/images/icon'.$arrowStyle.'_right.png) 0 '.$controlPositon.'px no-repeat; float:left;
}

#hotcarouselmodule-'.$uid.'.hotcarousel .carousel-previous {
	background: url('.$mosConfig_live_site.'/modules/mod_hot_joomla_carousel_pro/images/icon'.$arrowStyle.'_left.png) 0 '.$controlPositon.'px no-repeat; float:left;
}

#hotcarouselmodule-'.$uid.'.hotcarousel .carousel-control {
	height:'.$moduleHeightControl.'px;
	'.$arrowDisplayHTML.'
}

#hotcarouselmodule-'.$uid.' div.carousel-pagination a span {
	border:'.$buttonBorderSize.'px solid '.$buttonBorderColor.';
	padding:'.$buttonVertPadding.'px '.$buttonHorizPadding.'px;
	margin:1px;
	line-height:20px;
	background:'.$buttonBgColor.';
	'.$buttonRadiusHTML.'	
	cursor:pointer;
}

#hotcarouselmodule-'.$uid.' div.carousel-pagination span:hover, #hotcarouselmodule-'.$uid.'  div.carousel-pagination a.active span {
	background:'.$buttonBgColorActive.';
	cursor:pointer;
	border:'.$buttonBorderSizeActive.'px solid '.$buttonBorderColorActive.';
}

#hotcarouselmodule-'.$uid.' .carousel-wrap {
	width:'.$moduleWidth.'px;
	height:'.$moduleHeightControl.'px !important;
	float:left;
}

#hotcarouselmodule-'.$uid.'  .carouselarticle {
	background:'.$articleBgColor.';	
}

#hotcarouselmodule-'.$uid.'.hidecarousel {
	display:none;
}

' );

if($responsiveMode) {

$doc->addStyleDeclaration( '

#hotcarouselmodule-'.$uid.'.hotcarousel li .carouselarticle {
	min-width:'.$minimumWidth.'px;
}

' );

}

?>

<?php if ($enablejQuery!=0) { ?>
<script type="text/javascript" src="<?php echo $mosConfig_live_site; ?>/modules/mod_hot_joomla_carousel_pro/js/jquery.min.js"></script>
<?php } ?>
<?php if ($noConflict!=0) { ?>
<script type="text/javascript">
     jQuery.noConflict();
</script>
<?php } ?>

<script type="text/javascript">
jQuery(document).ready(function() {				   
		jQuery('#hotcarouselmodule-<?php echo $uid;?>').removeClass('hidecarousel');
});
</script>

<script type="text/javascript" src="<?php echo $mosConfig_live_site; ?>/modules/mod_hot_joomla_carousel_pro/js/jquery.carousel.min.js"></script>

<div id="hotcarouselmodule-<?php echo $uid;?>" class="hotcarousel hidecarousel">
    <div class="foo">
         <ul style="margin:0; padding:0">
    
			<?php
			
			if ($where == 'category' || $where == 'content') {
				// source is content category/item
				foreach ($html2out as $key => $value) {
					echo '<li class="carouselcontent"><div class="carouselarticle">'.$value.'<div class="clr"></div></div></li>';
				}
				
			}else{
			    
				$linksList = explode("\n", $imageLinks);
				$linksList = str_replace("\r", "", $linksList);
				$linksList = str_replace(" ", "", $linksList);
				$lCount = count($linksList);
				$loop = 0;
				$store_index = 0;
				while($loop < $lCount){
				 if($linksList[$loop]){
				   $linksList[$store_index] = $linksList[$loop];
				   if($linksList[$store_index] == "$$")
				    	$linksList[$store_index] = "javascript::void(0);";
				   $store_index++;
				 }
				 $loop++;
				}
				
				
				$carouselPath = $_SERVER['SCRIPT_FILENAME'];
				$carouselRealPath = substr_replace($carouselPath ,"",-9);
				$carouselFullPath = $carouselRealPath.$carouselImagesPath;
				$infinite_list = "";
				$linkTargetHTML = "";
				$fakeFiles = 0;
				$currentLink = "";
				$currentLinkClose = "";
				if ($handle = opendir($carouselFullPath)) {
				while (false !== ($file = readdir($handle))) {
					if ($file != "." && $file != "..") {
						$infinite_list = $infinite_list."$file"."||";
					}
					if ($file == ".") { $fakeFiles = $fakeFiles + 1; }
					if ($file == "..") { $fakeFiles = $fakeFiles + 1; }
				}
				closedir($handle);
					
				// edited may 2011
				$infinite_pic = explode("||", $infinite_list);
				$infinite_pics_number = count($infinite_pic);
				sort($infinite_pic);
				
				$lCount = count($infinite_pic);
				
				$loop = 0;
				$store_index = 0;
				while($loop < $lCount){
				 if($infinite_pic[$loop] && $infinite_pic[$loop] != "." && $infinite_pic[$loop] != ".."){
				   $infinite_pic[$store_index] = $infinite_pic[$loop];
				   $store_index++;
				 }
				 $loop++;
				}
				
				$linkTarget = $params->get('linkTarget','1'); 
                if ($linkTarget == "1") { $linkTargetHTML = ' target="_blank"'; }
					
				$loop_p = 0;
				for ($loop = 0; $loop < $infinite_pics_number ; $loop += 1) {
				    
					if(!isset($linksList[$loop])) $linksList[$loop] = "javascript::void(0);";
					
					$currentLink = '<a href="'.$linksList[$loop].'" '.$linkTargetHTML.' >';
					$currentLinkClose = '</a>';
					
					$pic_type = explode(".", $infinite_pic[$loop_p]);
					if(!isset($pic_type[1]))$pic_type[1] = "";
					while(!(
					 $pic_type[1]=="jpg" ||
					 $pic_type[1]=="gif" ||
					 $pic_type[1]=="jpeg" ||
					 $pic_type[1]=="png" ||
					 $pic_type[1]=="JPG" ||
					 $pic_type[1]=="GIF" ||
					 $pic_type[1]=="JPEG" ||
					 $pic_type[1]=="PNG"
					)){
					  $loop_p++;
					  if($loop_p > count($infinite_pic))
						 break;
					  $pic_type = explode(".", $infinite_pic[$loop_p]);
					  if(!isset($pic_type[1]))$pic_type[1] = "";
					}
					
					if ((($pic_type[1]=="jpg")or($pic_type[1]=="gif"))or(($pic_type[1]=="jpeg")or($pic_type[1]=="png"))) {
						echo '<li class="carouselimage">'.$currentLink.'<img src="'.$carouselImagesPath.'/'.$infinite_pic[$loop_p].'" alt="" width="'.$objectWidth.'" height="'.$objectHeight.'" class="reflect" />'.$currentLinkClose.'</li>';
						echo "\n";
					} elseif ((($pic_type[1]=="JPG")or($pic_type[1]=="GIF"))or(($pic_type[1]=="JPEG")or($pic_type[1]=="PNG"))) {
						echo '<li class="carouselimage">'.$currentLink.'<img src="'.$carouselImagesPath.'/'.$infinite_pic[$loop_p].'" alt="" width="'.$objectWidth.'" height="'.$objectHeight.'" />'.$currentLinkClose.'</li>';
						echo "\n";						
					}
					$loop_p++;
				}
				}
				
			}
            ?>
    
        </ul>

    </div>
</div>
<div class="clr"></div>
<?php
$reduceForBorder = $objectBorderWidth * 2;
$reduceForPadding = $objectPadding * 2;
$reduceForMargin = $objectMargin;
$minRequiredWidth = $articleNumber * $minimumWidth;
?>

<script type="text/javascript">
jQuery(document).ready(function() {		

	bodyWidth = jQuery('.hotcarousel').parent().innerWidth();
	minRequiredWidth = <?php echo $minRequiredWidth; ?>;

	itemsToDisplay = <?php echo $articleNumber; ?>;
	<?php if($responsiveMode) { ?>if ( bodyWidth < minRequiredWidth ) { itemsToDisplay = 1; }<?php } ?>

    jQuery("#hotcarouselmodule-<?php echo $uid;?> div.foo").carousel({
		direction: "<?php echo $carouselDirection; ?>",
		loop: <?php if ($carouselLoop) { echo "true"; }else{ echo "false"; } ?>,
		dispItems: itemsToDisplay,
		pagination: <?php if ($carouselPagination) { echo "true"; }else{ echo "false"; } ?>,
		paginationPosition: "inside",
		autoSlide: <?php if ($carouselAutoSlide) { echo "true"; }else{ echo "false"; } ?>,
		autoSlideInterval: <?php echo $carouselAutoSlideInterval; ?>,
		delayAutoSlide: false,
		combinedClasses: false,
		effect: "<?php echo $carouselEffect; ?>",
		slideEasing: "swing",
		animSpeed: "<?php echo $carouselAnimSpeed; ?>",
		equalWidths: "true"
	});
			   
	containerWidth = jQuery('.foo.js').innerWidth();
	usableContainerWidth = containerWidth - 32 * 2; // reduce for arrows width
	jQuery('#hotcarouselmodule-<?php echo $uid; ?> .carousel-wrap').css('width', usableContainerWidth);

	carouselArticleWidth = Math.round((usableContainerWidth / <?php echo $articleNumber; ?>) - <?php echo $reduceForBorder; ?> - <?php echo $reduceForPadding; ?> - <?php echo $reduceForMargin; ?>);
	jQuery('#hotcarouselmodule-<?php echo $uid; ?>.hotcarousel li div.carouselarticle').css("width", carouselArticleWidth);
	jQuery('#hotcarouselmodule-<?php echo $uid; ?>.hotcarousel li img').css("width", carouselArticleWidth);

/* what if no space */
<?php if($responsiveMode) { ?>
	<?php if($where!="images") { ?>minContainerWidth = jQuery('#hotcarouselmodule-<?php echo $uid; ?>.hotcarousel li div.carouselarticle').innerWidth();	
	overallMinContainerWidth = minContainerWidth * <?php echo $articleNumber; ?>;<?php }else{ ?>
	minContainerWidthIMG = jQuery('#hotcarouselmodule-<?php echo $uid; ?>.hotcarousel li img').innerWidth();
	overallMinContainerWidthIMG = minContainerWidthIMG * <?php echo $infinite_pics_number; ?>;<?php } ?>

	responsiveOneArticle = usableContainerWidth - <?php echo $reduceForBorder ?> - <?php echo $reduceForPadding ?> - <?php echo $objectMargin ?>;

	<?php if($where!="images") { ?>
	if( overallMinContainerWidth > usableContainerWidth ) {
		jQuery('#hotcarouselmodule-<?php echo $uid; ?>.hotcarousel li div.carouselarticle').css("width", responsiveOneArticle);
	}<?php }else{ ?>

	if( overallMinContainerWidthIMG > usableContainerWidth ) {
		jQuery('#hotcarouselmodule-<?php echo $uid; ?>.hotcarousel li img').css("width", responsiveOneArticle);
	}<?php } ?>
<?php } ?>
});
</script>
